const { resolve } = require('path');

module.exports = {
  configBaseDir: resolve(__dirname, 'node_modules'),
  extends: 'stylelint-config-recommended',
  rules: {
    'string-no-newline': true,
    'unit-no-unknown': true,
    'no-unknown-animations': true,
    'number-no-trailing-zeros': true,
    'property-case': 'lower',
    'at-rule-semicolon-newline-after': 'always',
    'value-list-max-empty-lines': 1,
    'unit-case': 'lower',
    'selector-pseudo-element-no-unknown': true,
    'no-invalid-double-slash-comments': true,
    'no-empty-source': true,
    'no-extra-semicolons': true,
    'function-max-empty-lines': 1,
    'comment-no-empty': true,
    'declaration-no-important': true,
    'keyframe-declaration-no-important': true,
    'declaration-block-no-duplicate-properties': true,
    'declaration-block-no-shorthand-property-overrides': true,
    'shorthand-property-no-redundant-values': true,
    'property-no-vendor-prefix': true,
    'value-no-vendor-prefix': true,
    'length-zero-no-unit': true,
    'comment-no-empty': true,
    'no-duplicate-selectors': true,
    'block-no-empty': true,
    'max-nesting-depth': 3,
    'value-no-vendor-prefix': true,
    'no-descending-specificity': null,
    'at-rule-no-unknown': [
      true,
      {
        ignoreAtRules: [
          'include',
          'function',
          'each',
          'return',
          'mixin',
          'else',
          'if',
          'for',
          'extend',
        ],
      },
    ],
  },
};
